<?php
/**
 * @file index.php
 * Main page
 * @author Roland Hieber (roland.hieber@wilhelm-gym.net)
 * @date 25.02.2008
 * 
 * Copyright © 2007 Roland Hieber
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

require_once("mod_room-reservation/globals.inc");
require_once("mod_room-reservation/mod_roomReservationBookingPage.inc");
$page = new mod_roomReservationBookingPage($g_rrCfg, $g_rrRm, $g_rrBm);
$page->setTitle(_c("room-reservation:Schedule of room bookings"));
$page->show();

/**
require_once("sec/secure.inc");
require_once("mod_rooms.inc");
TestConfig();

// Ist der User berechtigt?
$bAllowAccess = false;
foreach($user[groups] as $group)
{
    foreach($cfgRooms["AllowedGroups"] as $allowed)
    {
        $bAllowAccess |= (($group == $allowed) == true);
    }
}
if(!$bAllowAccess and $cfgRooms["RestrictAccess"] == true)
    die_nice("Fehler: Sie sind nicht berechtigt, diese Seite zu benutzen. Wenden Sie sich an einen Administrator.");

$bookings = new AllBookings(false);

// Zeitstunden in Schulstunden umrechnen
$lessons_begin = array_flip($cfgRooms["TimeslicesBegin"]);
$lessons_end = array_flip($cfgRooms["TimeslicesEnd"]);

$action = $_GET["action"];
$room = isset($_GET["room"]) ? $_GET["room"] : $cfgRooms["Rooms"][0];
$start = isset($_GET["start"]) ? $_GET["start"] : Monday();
$act = $user[act];
$id = isset($_POST["id"]) ? $_POST["id"] : $_GET["id"];
$class = isset($_POST["class"]) ? $_POST["class"] : $_GET["class"];
$room_form = isset($_POST["room_form"]) ? $_POST["room_form"] : $_GET["room"];
$date = isset($_POST["date"]) ? $_POST["date"] : $_GET["date"];
$timebegin = isset($_POST["timebegin"]) ? $_POST["timebegin"] : $_GET["timebegin"];
$timeend = isset($_POST["timeend"]) ? $_POST["timeend"] : (isset($_GET["timeend"]) ? $_GET["timeend"] : $cfgRooms["TimeslicesEnd"][$lessons_begin[$timebegin]]);    // Standardmäßig auf einen Zeitraum später als Anfangszeit
$reason = isset($_POST["reason"]) ? $_POST["reason"] : $_GET["reason"];
$submit = $_POST["submit"];
$cancel = $_POST["cancel"];

PageBlue("Raumbelegungsplan", "rooms_index");

// Formular anzeigen
function ShowForm()
{
    global $cfgRooms;
    global $act, $class, $room_form, $date, $timebegin, $timeend, $reason, $user;

    Title("Einen Raum buchen");
    $form = "<p>Füllen Sie das Formular aus und klicken Sie dann auf die Schaltfläche &bdquo;Raum buchen&ldquo;.</p>
<form action='?action=insert' method='post'>
<input type='hidden' name='id' value='$id' />
<table><tr>
 <td>Ihr Name:</td><td colspan='4'>{$user[name]}</td>
</tr>";

    // Klasse nur anzeigen, wenn angeschaltet
    if($cfgRooms["ShowClassEdit"])
        $form .= "<tr>\n <td>".q(stripslashes($cfgRooms["ClassEditText"])).":</td><td colspan='4'><input type='edit' style='width:100%' name='class' value='".q(stripslashes($class))."' /></td>\n</tr>";

    $form .= "<tr>\n <td>Raum:</td><td colspan='4'><select style='width:100%' name='room_form'>";
    foreach($cfgRooms["Rooms"] as $rm)
    {
        if($rm == $room_form)
            $form .= "<option selected='selected'>".q(stripslashes($rm))."</option>";
        else
            $form .= "<option>".q(stripslashes($rm))."</option>";
    }
    $form .= "</select></td>\n</tr><tr>\n";
    $form .= " <td>Datum:</td><td colspan='4'><input type='text' style='width:100%' name='date' value='".q(stripslashes($date))."' /></td>\n</tr><tr>\n";
    $form .= " <td>Zeit:</td><td>von</td><td><select style='width:60pt' name='timebegin'>";
    foreach($cfgRooms["TimeslicesBegin"] as $time)
    {
        if($time == $timebegin)
            $form .= "<option selected='selected'>".q(stripslashes($time))."</option>";
        else
            $form .= "<option>".q(stripslashes($time))."</option>";
    }
    $form .= "</select></td><td>bis</td><td><select style='width:60pt' name='timeend'>";
    foreach($cfgRooms["TimeslicesEnd"] as $time)
    {
        if($time == $timeend)
            $form .= "<option selected='selected'>".q(stripslashes($time))."</option>";
        else
            $form .= "<option>".q(stripslashes($time))."</option>";
    }
    $form .= "</select></td>\n</tr><tr>\n";
    $form .= " <td>Grund für die Belegung:</td><td colspan='4'><input type='text' style='width:100%' name='reason' value='".q(stripslashes($reason))."' /></td>\n</tr><tr>\n";
    $form .= " <td><input type='submit' class='stdbtn submit' name='submit' value='Raum buchen' />&nbsp;&nbsp;<input type='submit' class='stdbtn submit' name='cancel' value='Abbrechen' /></td>\n</tr></table></form>";

    echo $form;
}


if($action == "book")
{
    ShowForm();
}
// ...oder Buchung löschen?
else if($action == "delete")
{
    // Rausfinden, wo unsere gewünschte ID im Array steht
    for($n = 0; isset($bookings->objBookings[$n]->sqlData->id) and ($id != $bookings->objBookings[$n]->sqlData->id); $n++);

    // Auf Besitz oder Admin prüfen
    $bAdminMode = FALSE;
    $bAdminMode |= ($bookings->objBookings[$n]->UserIsOwner() and !$bookings->objBookings[$n]->rawData->fixed); // Benutzer dürfen keine festen Buchungen löschen
    $bAdminMode |= $bookings->UserIsAdmin();
    
    if(!$bAdminMode)
        echo "<div class='err'>Sie sind nicht berechtigt, diese Buchung zu löschen!</div>\n";
    else
    {
        if($_POST["surely_delete"] == "Löschen" && $_POST["surely_delete_fixed"] == "true")
        {
            $bookings->Delete($id);
            echo "<div class='err'>Ihre Buchung wurde gelöscht.</div>\n";
        }
        else
        {
            echo "<h1>Eine Buchung löschen</h1>\n";
            if($bookings->objBookings[$n]->rawData->fixed and $_POST["surely_delete_fixed"] == "false")
                echo "<p class='err'>Sie müssen bestätigen, dass Sie die Warnung über das Löschen von festen Buchungen zur Kenntnis genommen haben.</p>\n";
            // Formular zur Bestätigung anzeigen
            echo "<p>Wollen Sie diese Buchung löschen?<p>\n";
            $bookings->PrintBooking($id);
            echo "<br />\n";
            echo "<form action='?action=delete&amp;id=$id' method='post'>\n";
            if($bookings->objBookings[$n]->rawData->fixed)
                // Bestätigungsfeld für feste Buchungen
                echo "<p>".icona("dlg-warn", 16)."<b>Achtung:</b> Diese Buchung ist eine feste Buchung. Wenn sie gelöscht wird, wird der Zeitraum nicht in dieser Woche, sondern in <b>allen Wochen</b> wieder freigegeben.</p>\n<p><input type='hidden' name='surely_delete_fixed' value='false' /><$smlchk name='surely_delete_fixed' value='true' /><label for='surely_delete_fixed'>Ich habe diese Warnung zur Kenntnis genommen.</label></p>\n";
            else
                echo "<input type='hidden' name='surely_delete_fixed' value='true' />\n";
            echo "<$stdbtn name='surely_delete' value='Löschen' /></form>\n";
        }
    }

    // Zurück-Link anzeigen
    Option(_("Back"), "", "href='?room=$room&amp;start=$start'", "back");
}

// ... oder alle Buchungen anzeigen / Buchung eintragen?
else
{
    if($action == "insert" and $submit == "Raum buchen")
    {
        $err = $bookings->Insert(null, $room_form, $date, $timebegin, $timeend, $act, $class, $reason, false);
        if(!$err)
        {
            switch($bookings->lastError)
            {
                case ALLBOOKINGS_SQL_ERROR:
                    ReportError("\$booking->Insert", $booking->lastError, __FILE__, __LINE__);
                default:
            }
            ShowForm();
            die_nice();
        }
        else
        {
            // Log-Eintrag, wenn erwünscht
            if($cfgRooms["LogOnInsert"])
                InsertLog("Raum $room_form am $date von $timebegin bis $timeend gebucht. Begründung: $reason");

            // Passenderweise gleich die Woche mit der eingetragenen Buchung anzeigen
            $tmp = explode(".", $date);
            $start = Monday(strtotime($tmp[2]."-".$tmp[1]."-".$tmp[0]));
            $room = $room_form;
            Title("Raumbelegungen für den Raum $room in Woche ".date("W", $start));
            echo "<p class='err'>".icona("dlg-info", 16, "bl")."Ihre Buchung wurde eingetragen.</p>\n";
        }
    }
    else
    {
        Title("Raumbelegungen für den Raum $room in Woche ".date("W", $start));
    }

    $nPrevWeek = strtotime("last monday", Monday($start));  // der Montag vor dem Montag in der Startwoche
    $nFirstWeek = Monday();                                 // der Montag in der aktuellen Woche
    $nLastWeek = strtotime("last monday", Monday($bookings->GetLastBookingDate()));
    $nNextWeek = strtotime("next monday", Monday($start));       // der Montag nach dem Montag der Startwoche

    echo "<form action=''>
Raum: <select onchange='window.location.href=\"{$_SERVER["PHP_SELF"]}?start=$start&amp;room=\" + this.options[this.options.selectedIndex].text;' width='250'>\n";
    foreach($cfgRooms["Rooms"] as $opt)
    {
        echo " <option";
        if($opt == $room)
            echo " selected='selected'";
        echo ">".q(stripslashes($opt))."</option>\n";
    }
    echo "</select></form></p>";

    // Navigation für die Wochen ausgeben
    echo "<p><a href='?start=$nPrevWeek&amp;room=".qu(stripslashes($room))."' title='Zur vorherigen Woche blättern'>Vorherige Woche</a> | <a href='?start=$nFirstWeek&amp;room=".qu(stripslashes($room))."' title='Zur aktuellen Woche blättern'>Aktuelle Woche</a> | ";
    // Fünf Wochen zur direkten Anwahl anbieten
    for($i = 1; $i <= 5; $i++)
    {
        $nCurWeek = Monday(strtotime("$i week", $start));
        echo "<a href='?start=$nCurWeek&amp;room=".qu(stripslashes($room))."' title='Zu Woche ".date("W", $nCurWeek)." blättern'>Woche ".date("W", $nCurWeek)."</a> | ";
    }
    echo "<a href='?start=$nLastWeek&amp;room=".qu(stripslashes($room))."' title='Zur Woche mit der letzen Buchung blättern'>Letzte Buchung</a> | <a href='?start=$nNextWeek&amp;room=".qu(stripslashes($room))."' title='Zur nächsten Woche blättern'>Nächste Woche</a></p>";
    echo "<p><ul>
 <li>Um eine Buchung vorzunehmen dort auf &bdquo;Ab hier buchen&ldquo; klicken, wo die Buchung beginnen soll.</li>
 <li><b>Neu:</b> Eigene Buchungen (au&szlig;er den wiederkehrenden Buchungen in dunkelblau) können gelöscht werden, indem auf den Link &bdquo;Buchung löschen&ldquo; geklickt wird.</li>
 <li>Mit Klick auf den Benutzernamen kann eine E-Mail an den Benutzer geschrieben werden.</li>
</ul></p>\n";

    $bookings->PrintTimeTable($start, $room);

    echo "<br />";
}

_PageBlue();
*/
?>
